#include <sockapi.h>
#include <socket.h>
#include <stdlib.h>

// Codes from 3.0
#define  AF_INET     2     /* internetwork: UDP, TCP, etc. */
#define  PF_INET     AF_INET
#define  SOCKET_ERROR   -1    /* error return from send(), sendto(), et.al. */

//
// application creates a server socket which can be connected to by a client.
// once socket is created, application monitors the socket for the first connection
// and echos out any incoming infomation back to the client.
void datapipe(unsigned long clientSocketDescriptor);

int echoSocket( unsigned short PortNumber)
{

#define listenBacklog 1

    int serverSocketDescriptor, serverSocketDomain, serverSocketType, serverSocketProtocol;
    int clientSocketDescriptor, retVal;
    struct sockaddr_in clientSocket, serverSocket;
    char* dyn_name;
    int clientSocketSize, socketPacketLength, socketPacketAttributes;
    int recvPacketLength, level, optName, retryCount;
    int block =1;
    unsigned long addr;
    void *stackP;
    int thread_number=0;
    TX_THREAD *dyn_thread; // Thread control blocks will be dynamically allocated in heap

    //
    // create SERVER socket
    //
    serverSocketDomain=0;
    serverSocketType=SOCK_STREAM;
    serverSocketProtocol=PF_INET;
    serverSocketDescriptor = socket(serverSocketProtocol,
	    serverSocketType,
	    serverSocketDomain);
    if (serverSocketDescriptor<0)
	return (-1);	// failure

    printf ("server socket now created\n");


    //Set Socket Option
    
retVal = setsockopt(serverSocketDescriptor , SOL_SOCKET, SO_NONBLOCK, (char *)&block, sizeof(block));
    
    if (retVal < 0)
    {
        printf("TCPserverd: setsockopt SO_NONBLOCK failure: errno: %d\n", getErrno());
        closesocket(serverSocketDescriptor);
        return;
    }

    //
    // bind SERVER socket to PortNumber, any IP
    //
    serverSocket.sin_family=AF_INET;
    serverSocket.sin_port=PortNumber;
    serverSocket.sin_addr.s_addr=INADDR_ANY;
    retVal=bind(serverSocketDescriptor, &serverSocket, sizeof(serverSocket));
    if (retVal != SOCKET_ERROR)
    {
	printf ("server socket bind OK\n");
    }
    else
    {
	// can't bind it, so don't use it
	socketclose(serverSocketDescriptor);
	// set id to indicate bind failure
	serverSocketDescriptor=-1;
	return (serverSocketDescriptor);
    }

    //
    // set up server socket to receive a connection
    //  backlog determines max length of 
    //  queue for pending client connections
    //
    retVal = listen(serverSocketDescriptor,  listenBacklog);
    if (retVal<0)
    {
	//
	// close socket and return indicating failure
	//
	socketclose(serverSocketDescriptor);
	return (retVal);
    }

    printf ("server socket now listening for client on port %d\n", PortNumber);
    printf ("Backlog of %d\n", listenBacklog);

    while(1)
    {
	//
	// monitor server socket for client connection
	//
	clientSocketSize = sizeof (clientSocket); 
	clientSocketDescriptor=-1;
	retryCount=0;
	// accept client connection request


	
	retVal = accept(serverSocketDescriptor,
		&clientSocket,
		&clientSocketSize);

	// check if client socket connection created
	if (retVal>0)
	{
	    addr=clientSocket.sin_addr.s_addr;
	    clientSocketDescriptor=retVal;
	    printf("Connected to client %ld.%ld.%ld.%ld; remote port %d\n",
		    addr>>24, (addr>>16)& 0xff, (addr>>8)&0xff, addr&0xff, clientSocket.sin_port);




    //Set Socket Option
// test case 2  retVal = setsockopt(clientSocketDescriptor , SOL_SOCKET, SO_NONBLOCK, (char *)&block, sizeof(block));
    if (retVal < 0)
    {
        printf("TCPserverd: setsockopt SO_NONBLOCK failure: errno: %d\n", getErrno());
        closesocket(serverSocketDescriptor);
        return;
    }
	    
//Create Thread For accepted socket connection to pass data to and fro



	    
	    stackP=malloc(4096);
	    dyn_thread = malloc(sizeof(TX_THREAD));
	    dyn_name = malloc(20);
	    
	    sprintf(dyn_name, "Com_Thread #%d", thread_number++);
	    
	    retVal = tx_thread_create (dyn_thread,                      /* control block for root thread*/
		    dyn_name,                      /* thread name*/
		    datapipe,                       /* entry function*/
		    clientSocketDescriptor,             /* parameter*/
		    stackP,                /* start of stack*/
		    2048,                /* size of stack*/
		    16,                  /* priority*/
		    16,                  /* preemption threshold */
		    1,                                  /* time slice threshold*/
		    TX_AUTO_START);                     /* start immediately*/

	    if (retVal != TX_SUCCESS)                                    /* if couldn't create thread*/
	    {
		netosFatalError ("Unable to create root thread", 1, 1);
	    }
	    else
	    {
		printf("Data Pipe Created, Thread ID %s\n\n", dyn_name);
	    }
	}
    }
}

